/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.utilities;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author bfrosik
 * @param <K1>
 * @param <K2>
 * @param <E>
 */
public class DoubleKeyMap <K1, K2, E> {
    private final Map<K1, E> map1 = new HashMap<>();
    private final Map<K2, E> map2 = new HashMap<>();
    
    public void put(K1 key1, K2 key2, E value) {
        map1.put(key1, value);
        map2.put(key2, value);
    }
    
    public E getByFirstKey(K1 key1) {
        return map1.get(key1);
    }

    public E getBySecondKey(K2 key2) {
        return map2.get(key2);
    }
    
    public void remove(K1 key1, K2 key2) {
        map1.remove(key1);
        map2.remove(key2);
    }
    
    public Collection<E> values() {
        return map1.values();
    }

    public Collection<K1> firstKeySet() {
        return map1.keySet();
    }

    public Collection<K2> secondKeySet() {
        return map2.keySet();
    }
    
    public void clear() {
        map1.clear();
        map2.clear();
    }
}
